
#pragma used+
sfrb PINA=0;
sfrb DDRA=1;
sfrb PORTA=2;
sfrb PINB=3;
sfrb DDRB=4;
sfrb PORTB=5;
sfrb PINC=6;
sfrb DDRC=7;
sfrb PORTC=8;
sfrb PIND=9;
sfrb DDRD=0xa;
sfrb PORTD=0xb;
sfrb PINE=0xc;
sfrb DDRE=0xd;
sfrb PORTE=0xe;
sfrb PINF=0xf;
sfrb DDRF=0x10;
sfrb PORTF=0x11;
sfrb PING=0x12;
sfrb DDRG=0x13;
sfrb PORTG=0x14;
sfrb TIFR0=0x15;
sfrb TIFR1=0x16;
sfrb TIFR2=0x17;
sfrb TIFR3=0x18;
sfrb TIFR4=0x19;
sfrb TIFR5=0x1a;
sfrb PCIFR=0x1b;
sfrb EIFR=0x1c;
sfrb EIMSK=0x1d;
sfrb GPIOR0=0x1e;
sfrb EECR=0x1f;
sfrb EEDR=0x20;
sfrb EEARL=0x21;
sfrb EEARH=0x22;
sfrw EEAR=0X21;   
sfrb GTCCR=0x23;
sfrb TCCR0A=0x24;
sfrb TCCR0B=0x25;
sfrb TCNT0=0x26;
sfrb OCR0A=0x27;
sfrb OCR0B=0x28;
sfrb GPIOR1=0x2a;
sfrb GPIOR2=0x2b;
sfrb SPCR=0x2c;
sfrb SPSR=0x2d;
sfrb SPDR=0x2e;
sfrb ACSR=0x30;
sfrb OCDR=0x31;
sfrb SMCR=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb SPMCSR=0x37;
sfrb RAMPZ=0x3b;
sfrb EIND=0x3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.EQU __sm_ext_standby=0x0E
	.EQU __sm_adc_noise_red=0x02
	.SET power_ctrl_reg=smcr
	#endif
#endasm

char len;
flash char encodeTable[] =
{'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':', ';', '<', '=', '>', '?',
'@', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e',
'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u'};
volatile char sms[];
char stroka[]={0xB1,0x9A,0xFF,0x2B,0x79,0xEE,0x31,0x46,0x32,0x2E,0x83,0xDD,0x1B,0x0,0x0,
0x01,0x0,0x0,0x9A,0x7E,0x09,0x00,0x00,0x00,0x0C,0x01,0x00,0x00,0x00,0x00,0xFE};

#pragma used+
char getchar3(void)
{
char status,data;
while (1)
{
while (((status=(*(unsigned char *) 0x130)) & (1<<7))==0);
data=(*(unsigned char *) 0x136);
if ((status & ((1<<4) | (1<<2) | (1<<3)))==0)
return data;
};
}
#pragma used-

#pragma used+
void putchar3(char c)
{
while (((*(unsigned char *) 0x130) & (1<<5))==0);
(*(unsigned char *) 0x136)=c;
}
#pragma used-

#pragma used+
void send(char *mas)
{
char data;
while (*mas)
{
data = *mas++;
putchar3(data);
}

}
#pragma used-

char EncodeData(char data[])
{
char len0, i, index;
char a0, a1, a2;
char b0, b1, b2, b3;

len0=len/3-1;

for(i=0;i<len0; i=i+1)
{
index=i*3;
a0 = data[index];
putchar3(a0);
putchar3(index);
putchar3('\n');

index=i*3+1;
a1 = data[index];
putchar3(a1);
putchar3(index);
putchar3('\n');

index=i*3+2;
a2 = data[index];
putchar3(a2);
putchar3(index);
putchar3('\n');

b0 = a0&0x3F;
b1 = ((a1&0x0F)<<2)|(a0>>6);
b2 = ((a2&0x03)<<4)|(a1>>4);
b3 = a2>>2;

sms[i*4]=encodeTable[b0];
sms[i*4+1]=encodeTable[b1];
sms[i*4+2]=encodeTable[b2];
sms[i*4+3]=encodeTable[b3];

}

return (*sms);
}

void main(void)
{

#pragma optsize-
(*(unsigned char *) 0x61)=0x80;
(*(unsigned char *) 0x61)=0x00;
#pragma optsize+

(*(unsigned char *) 0x130)=0x00;
(*(unsigned char *) 0x131)=0x18;
(*(unsigned char *) 0x132)=0x06;
(*(unsigned char *) 0x135)=0x00;
(*(unsigned char *) 0x134)=0x01;

ACSR=0x80;
(*(unsigned char *) 0x7b)=0x00;

len=sizeof(stroka);
send(stroka);
putchar3('\n');
EncodeData(stroka);
send(sms);
putchar3('\n');

while (1)
{ 

};
}
